package com.btc.ep.base.dal.tests.it;

import javax.persistence.EntityManager;

import org.junit.Before;
import org.junit.Test;

import com.btc.ep.base.bl.impl.TCStepImpl;
import com.btc.ep.core.Services;
import com.btc.ep.dal.persist.PersistenceService2;

public class SetAndRemoveIssue {

	private static PersistenceService2 persistenceService2;

	private static final String VECTOR_ID = "v-id";
	private static final long STEP_NUMBER = 0L;

	private static EntityManager em;

	@Before
	public void setUp() throws Exception {
		deleteDatabase();
	}

	@Test
	public void test() {

		TCStepImpl a = new TCStepImpl(VECTOR_ID, STEP_NUMBER);
		getPersistenceService2().persist(a);

		getPersistenceService2().commit();

		a = findStepBefore(VECTOR_ID, STEP_NUMBER + 1);
		a.setStepDuration(2);

		a = findStepWithStepNumber(VECTOR_ID, STEP_NUMBER);
		getPersistenceService2().remove(a);

		getPersistenceService2().commit();

		System.out.println("ok");
	}

	public TCStepImpl findStepBefore(String vectorID, long stepNumber) {
		String sql = "SELECT s FROM " + TCStepImpl.class.getSimpleName()
				+ " s WHERE s.vectorID == ?1 AND s.stepNumber < ?2 ORDER BY s.stepNumber DESC";
		return getPersistenceService2().getModelElementByQuery(sql, TCStepImpl.class, vectorID, stepNumber);
	}

	public TCStepImpl findStepWithStepNumber(String vectorID, long stepNumber) {
		String sql = "SELECT s FROM " + TCStepImpl.class.getSimpleName()
				+ " s WHERE s.vectorID == ?1 AND s.stepNumber == ?2";
		return getPersistenceService2().getModelElementByQuery(sql, TCStepImpl.class, vectorID, stepNumber);
	}

	protected void deleteDatabase() {
		getPersistenceService2().updateQuery("DELETE FROM Object");
	}

	public PersistenceService2 getPersistenceService2() {
		if (persistenceService2 == null) {
			persistenceService2 = Services.get(PersistenceService2.class);
		}
		return persistenceService2;
	}
}
