package optimisticlockwithremove.dmo.impl;

import java.util.Date;
import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.Map.Entry;
import java.util.Set;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.OneToMany;

import optimisticlockwithremove.dmo.Architecture;
import optimisticlockwithremove.dmo.Scope;

@Entity
@Access (AccessType.FIELD)
public class ArchitectureImpl extends NamedElementImpl implements Architecture {

    private static final String ARCHITECTURE_LABEL = "Architecture";

    @OneToMany (targetEntity = ScopeImpl.class, cascade = CascadeType.ALL, orphanRemoval = true)
    private Set<ScopeImpl> rootScopes = new LinkedHashSet<ScopeImpl>();

    @Basic
    private String creator;

    @Basic
    private Date importDate;

    @Basic
    private boolean isMaster;

    @Basic
    private boolean visible;

    @Basic
    private String compilerSetupKey;

    public ArchitectureImpl() {
    }

    public Set<ScopeImpl> getRootScopes() {
        return rootScopes;
    }

    public void setRootScopes(Set<ScopeImpl> rootScopes) {
        this.rootScopes = rootScopes;
    }

    @Override
    public String getCreator() {
        return creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    @Override
    public Date getImportDate() {
        return importDate;
    }

    public void setImportDate(Date importDate) {
        this.importDate = importDate;
    }

    public void removeRootScope(Scope rootScope) {
        rootScopes.remove(rootScope);
    }

    public void addRootScope(ScopeImpl rootScope) {
        rootScopes.add(rootScope);
    }

    @Override
    public boolean isMaster() {
        return isMaster;
    }

    public void setIsMaster(boolean isMaster) {
        this.isMaster = isMaster;
    }

    @Override
    public boolean isVisible() {
        return visible;
    }

    public void setVisible(boolean visible) {
        this.visible = visible;
    }

    @Override
    public String getCompilerSetupKey() {
        return compilerSetupKey;
    }

    public void setCompilerSetupKey(String compilerSetupKey) {
        this.compilerSetupKey = compilerSetupKey;
    }

    @Override
    public String getArchitectureLabel() {
        return ARCHITECTURE_LABEL;
    }

    @Override
    public HashSet<String> getKeyWords() {
        return null;
    }

    @Override
    public HashSet<String> getAccessPathOperators() {
        return null;
    }

    @Override
    public Set<Entry<String, String>> getMetaInfo() {
        return null;

    }
}
