package optimisticlockwithremove.dmo.impl;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.OneToMany;

import optimisticlockwithremove.dmo.Mapping;
import optimisticlockwithremove.dmo.ModelElement;

@Entity
@Access (AccessType.FIELD)
public class MappingImpl extends ModelElementImpl implements Mapping {

	@OneToMany(cascade = { CascadeType.PERSIST, CascadeType.MERGE, CascadeType.REFRESH,
			CascadeType.DETACH }, targetEntity = ModelElementImpl.class)
	private List<ModelElement> values = new ArrayList<ModelElement>();

	public MappingImpl() {
	}

	@Override
	public List<ModelElement> getValues() {
		return values;
	}

	@Override
	public void addValue(ModelElement value) {
		this.values.add(value);
	}

	@Override
	public void removeValue(ModelElement value) {
		this.values.remove(value);

	}

}
