package optimisticlockwithremove.dmo.impl;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.ManyToOne;
import javax.persistence.criteria.Expression;

import optimisticlockwithremove.dmo.PatternParameter;
import optimisticlockwithremove.dmo.SimplifiedUniversalPattern;

@Entity
@Access (AccessType.FIELD)
public abstract class PatternParameterImpl extends ModelElementImpl implements PatternParameter {

    @ManyToOne (targetEntity = SimplifiedUniversalPatternImpl.class)
    private SimplifiedUniversalPattern pattern;

    @Basic
    private String expressionId;

    @Basic
    private String displayName;

    @Basic
    private Map<String, String> mergedScopeAndExpressionMap;

    public PatternParameterImpl(SimplifiedUniversalPattern pattern, String expressionId, String displayName) {
        this.pattern = pattern;
        this.expressionId = expressionId;
        this.displayName = displayName;

        mergedScopeAndExpressionMap = new HashMap<String, String>();
    }

    protected PatternParameterImpl() {
    }

    @Override
    public SimplifiedUniversalPattern getPattern() {
        return pattern;
    }

    @Override
    public String getDisplayName() {
        return displayName;
    }

    public String getExpressionId() {
        return expressionId;
    }

    public void setExpressionIDForScope(String scopeID, String exprID) {
        mergedScopeAndExpressionMap.put(scopeID, exprID);
    }

    public String getExpressionIDForScope(String scopeID) {
        return mergedScopeAndExpressionMap.get(scopeID);
    }

    public Map<String, String> getScopeAndExpressionMap() {
        return mergedScopeAndExpressionMap;
    }

    public abstract PatternParameter copy(SimplifiedUniversalPattern pattern, Expression expression);

    public <T extends PatternParameterImpl> T copyValuesTo(T copy) {
        return copy;
    }

    public void setExpressionId(String uid) {
        this.expressionId = uid;
    }

}