package optimisticlockwithremove.dmo.impl;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Basic;
import javax.persistence.Entity;

import optimisticlockwithremove.dmo.Requirement;
import optimisticlockwithremove.dmo.RequirementReference;

@Entity
@Access (AccessType.FIELD)
public class RequirementReferenceImpl extends ModelElementImpl implements RequirementReference {

    @Basic
    private Requirement requirement;
    @Basic
    private String refElementID;

    @Basic
    private int bIndex;
    @Basic
    private int eIndex;
    @Basic
    private String text;

    public RequirementReferenceImpl(Requirement requirement, String text, String refElement, int bIndex, int eIndex) {
        this.requirement = requirement;
        this.refElementID = refElement;
        this.bIndex = bIndex;
        this.eIndex = eIndex;
        this.text = text;
    }

    protected RequirementReferenceImpl() {
        this(null, "", "", -1, -1);
    }

    @Override
    public int getBeginIndex() {
        return this.bIndex;
    }

    public void setBeginIndex(int index) {
        this.bIndex = index;
    }

    @Override
    public int getEndIndex() {
        return eIndex;
    }

    public void setEndIndex(int index) {
        this.eIndex = index;
    }

    @Override
    public String getReferencingElementID() {
        return refElementID;
    }

    @Override
    public Requirement getRequirement() {
        return requirement;
    }

    @Override
    public String getText() {
        return text;
    }
}